<?php
	
	ini_set('max_execution_time', 900);
	
	class backendUnfinder extends cmsBackend {
		
		protected $useOptions = true; // Включаем опции компонента
		
		public $useDefaultOptionsAction = true; // Включаем дефолтный набор опций
		
		public function actionIndex(){
			$this->redirectToAction('options');
		}
		
		/* Выводим меню */
		public function getBackendMenu(){
			return array(
            array(
			'title' => LANG_UNFINDER_BACKEND_TAB_OPTIONS,
			'url' => href_to($this->root_url, 'options')
            ),
            array(
			'title' => LANG_UNFINDER_BACKEND_TAB_LINKS,
			'url' => href_to($this->root_url, 'links')
            ),
            array(
			'title' => LANG_UNFINDER_BACKEND_TAB_FILES,
			'url' => href_to($this->root_url, 'files')
            ),
            array(
			'title' => LANG_UNFINDER_BACKEND_TAB_COMPARE,
			'url' => href_to($this->root_url, 'compare')
            ),
            array(
			'title' => LANG_UNFINDER_BACKEND_TAB_MOVE,
			'url' => href_to($this->root_url, 'move')
            ),
            array(
			'title' => LANG_UNFINDER_BACKEND_TAB_ARCH,
			'url' => href_to($this->root_url, 'arch')
            ),
            /*{comgen-backend-menu}*/
			);
		}
		
		/* Получаем таблицы, в которых есть нужные поля */
		public function getTables(){
			$config = cmsConfig::getInstance();
			$columns_options = $this->options['columns']; // Поля, которые будем искать во всех таблицах базы
			
			/* Приводим строку с полями к нужному виду */
			$colu = str_replace(' ', '', $columns_options);
			$co = str_replace(',', '","', $colu);
			
			/* Получаем имена таблиц и полей */
			$sql = $this->model->db->query("SELECT TABLE_NAME, COLUMN_NAME FROM INFORMATION_SCHEMA.COLUMNS 
			WHERE COLUMN_NAME IN (\"{$co}\")
			AND TABLE_SCHEMA = '{$config->db_base}'");
			
			/* Заносим таблици и поля в массив */
			while ($cols = $this->model->db->fetchAssoc($sql)){
				$cols['TABLE_NAME'] = str_replace($config->db_prefix, '', $cols['TABLE_NAME']);
				$columns[] = $cols;
			}
			/* Преобразуем массив в json и записываем в файл */
			$clmns = fopen('upload/columns.json', 'w') or die("не удалось создать файл");
			fwrite($clmns, json_encode($columns));
			fclose($clmns);
			cmsUser::addSessionMessage('Найдено таблиц: '.count($columns), 'success');
			return $columns;
		}
		
		/* Получаем имена файлов, ссылки на которые имеются в базе данных */
		public function getLinks(){
			
			$extensions = $this->options['extensions']; // Получаем расширения файлов, которые будем искать
			
			$exto = str_replace(' ', '', $extensions); // Убираем пробелы
			
			$ex = str_replace(',', '|', $exto); // Приводим строку к нужному виду
			
			$cls = file_get_contents('upload/columns.json', 'r') or die("не удалось открыть файл"); // Получаем содержимое файла 
			
			$col = json_decode($cls, true); // Преобразуем json в массив
			
			/* Перебираем массив с таблицами и производим выборку из них */
			foreach($col as $co){
				
				/* Вырезаем только имена файлов изображений */
				if (preg_match_all('/[a-z0-9-_]+\.('.$ex.')/', json_encode($this->model->db->getRows($co['TABLE_NAME'], "{$co['COLUMN_NAME']} REGEXP '".$ex."'" ,  $co['COLUMN_NAME'])), $matches)){
					$img[] = $matches[0];
				}
			}
			$dot = array('[',']', '"', '""'); // Символы, которые будем вырезать 
			
			$img_str = str_replace ($dot, '',json_encode($img)); // Преобразуем массив имен файлов в одномерный массив
			
			$links = array_unique(explode(',', $img_str)); // Повторяющиеся имена файлов тоже вырезаем
			
			/* Преобразуем массив в json и запиываем в файл */
			$lnks = fopen('upload/links.json', 'w') or die("не удалось создать файл");
			fwrite($lnks, json_encode($links));
			fclose($lnks);
			
			return count($links);
		}
		
		
		/* Получаем все имена файлов в папке upload */
		public function getFiles() {
			
			$config = cmsConfig::getInstance();
			
			$ext_options = $this->options['extensions']; // Получаем расширения файлов
			
			$dot = array('[',']', '"', '""'); // Массив символов, которые будем вырезать
			
			$path = $config->upload_path.'/000';
			
			$exto = str_replace(' ', '', $ext_options); // Удаляем пробелы
			$ex = str_replace(',', '|', $exto); // Приводим строку к нужному виду
			
			/* Рекурсивно сканируем папку загрузок и заносим имена файлов в массив */
			$objects = new RecursiveIteratorIterator(new RecursiveDirectoryIterator($path), RecursiveIteratorIterator::SELF_FIRST);
			foreach($objects as $name => $object){
				
				if ( !strpos($name, 'default') && !strpos($name, 'installer') && !strpos($name, 'files')) {
					if (preg_match_all('/[a-z0-9-_]+\.('.$ex.')/', $name, $matches)){
						$filelist[] = $matches[0][0];
					}
				}
			}
			$fl_s = str_replace ($dot, '',json_encode($filelist)); // Преобразуем массив в одномерный json
			$fl_str = str_replace (array('\\','"'), '',json_encode($fl_s));
			$fl_array = array_unique(explode(',', $fl_str)); // Обратно в массив и удаляем неуникальные элементы
			
			/* Преобразуем обратно в json и записываем в файл */
			$fls = fopen('upload/files.json', 'w') or die("не удалось создать файл");
			fwrite($fls, json_encode($fl_array));
			fclose($fls);
			cmsUser::addSessionMessage('Найдено файлов: '.count($fl_array), 'success');
			return count($fl_array);
			
		}
		
		/* Сравниваем два массива (ссылки и файлы), результат преобразуем в json и записываем в файл */
		public function compare(){
			$fls = file_get_contents('upload/files.json', 'r') or die("не удалось открыть файл");
			$files = json_decode($fls, true);
			$lnks = file_get_contents('upload/links.json', 'r') or die("не удалось открыть файл");
			$links = json_decode($lnks, true);
			$compare = array_diff($files, $links);
			$dl = fopen('upload/compare.json', 'w') or die("не удалось создать файл");
			fwrite($dl, json_encode($compare));
			fclose($dl);
			return count($compare);
			
		}
		
		/* Создаем копию папок upload и пишем туда лишние файлы */
		public function move(){
			
			$config = cmsConfig::getInstance();
			
			$extensions = $this->options['extensions'];
			
			$path = "upload";
			
			$cmpr = file_get_contents("upload/compare.json", "r") or die("не удалось открыть файл");
			$compare = json_decode($cmpr, true);
			$exto = str_replace(' ', '', $extensions);
			$ex = str_replace(',', '|', $exto);
			
			if (!file_exists('deleted')){mkdir("deleted", 0777, true); chmod("deleted", 0777);} // Если нет папки deleted - создаем
			$objects = new RecursiveIteratorIterator(new RecursiveDirectoryIterator($path), RecursiveIteratorIterator::SELF_FIRST);
			foreach( $objects as $v ){
				
				if( $v->isDir() && !file_exists("deleted/".$v->getPath())){
					
					
					mkdir("deleted/".$v, 0777, true); chmod("deleted/".$v, 0777);
				}
			}
			$count = 0;
			
			foreach($objects as $name => $object){
				
				
				if (preg_match_all('/[a-z0-9-_]+\.('.$ex.')/', $name, $matches)){
					
					if (in_array($matches[0][0], $compare))
					{
						
						rename($name, "deleted/".$name);
						$count++;
					}
				}
				
			}
			cmsUser::addSessionMessage('Перенесено файлов: '.$count, 'success');
			return $count;
		}
		
		/* Удаляем пустые папки в upload и в deleted */
		public function clean(){
			
			$count_del = 0;
			$count_upl = 0;
			
			$delpath = PATH . DIRECTORY_SEPARATOR .'deleted';
			
			
			if (file_exists('deleted')){
				$deldir = new RecursiveIteratorIterator( new RecursiveDirectoryIterator( $delpath, FilesystemIterator::SKIP_DOTS ), RecursiveIteratorIterator::CHILD_FIRST );
				
				
				foreach( $deldir as $v ){
					
					if( $v->isDir() and $v->isWritable() ){
						
						@rmdir( $deldir->key() ) === true ? $count_del++ : false;
						
					}
				}
			}
			$path = PATH . DIRECTORY_SEPARATOR .'upload' . DIRECTORY_SEPARATOR . '000';
			
			
			$updir = new RecursiveIteratorIterator( new RecursiveDirectoryIterator( $path, FilesystemIterator::SKIP_DOTS ), RecursiveIteratorIterator::CHILD_FIRST );
			
			
			foreach( $updir as $v ){
				
				if( $v->isDir() and $v->isWritable() ){
					
					@rmdir( $updir->key() ) === true ? $count_upl++ : false;
					
				}
			}
			
			return $count_del + $count_upl;
		}
		
		/* Упаковываем в zip папку deleted */
		public static function zip(){
			
			$source = 'deleted'; $destination = 'deleted.zip';
			
			if (!extension_loaded('zip') || !file_exists($source)) {
				return false;
			}
			
			$zip = new ZipArchive();
			if (!$zip->open($destination, ZIPARCHIVE::CREATE)) {
				return false;
			}
			
			$source = str_replace('\\', DIRECTORY_SEPARATOR, realpath($source));
			$source = str_replace('/', DIRECTORY_SEPARATOR, $source);
			
			if (is_dir($source) === true) {
				$files = new RecursiveIteratorIterator(new RecursiveDirectoryIterator($source),
				RecursiveIteratorIterator::SELF_FIRST);
				
				foreach ($files as $file) {
					$file = str_replace('\\', DIRECTORY_SEPARATOR, $file);
					$file = str_replace('/', DIRECTORY_SEPARATOR, $file);
					
					if ($file == '.' || $file == '..' || empty($file) || $file == DIRECTORY_SEPARATOR) {
						continue;
					}
					// Ignore "." and ".." folders
					if (in_array(substr($file, strrpos($file, DIRECTORY_SEPARATOR) + 1), array('.', '..'))) {
						continue;
					}
					
					$file = realpath($file);
					$file = str_replace('\\', DIRECTORY_SEPARATOR, $file);
					$file = str_replace('/', DIRECTORY_SEPARATOR, $file);
					
					if (is_dir($file) === true) {
						$d = str_replace($source . DIRECTORY_SEPARATOR, '', $file);
						if (empty($d)) {
							continue;
						}
						$zip->addEmptyDir($d);
						} elseif (is_file($file) === true) {
						$zip->addFromString(str_replace($source . DIRECTORY_SEPARATOR, '', $file),
						file_get_contents($file));
						} else {
						// do nothing
					}
				}
				} elseif (is_file($source) === true) {
				$zip->addFromString(basename($source), file_get_contents($source));
			}
			
			return $zip->close();
		}
		
		
		
		
	}
